package uy.edu.chesstrack.communication;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import android.util.Log;

public class Client {

	private static final String TAG = "CLIENT";
	private static Client _clientInstance;

	private Socket _serverSocket;
	private int _serverPort;
	private String _serverIp;

	// private BufferedReader _input;
	private DataOutputStream _output;

	protected Client() {

	}

	public static Client getInstance() {
		if (_clientInstance == null) {
			_clientInstance = new Client();
		}
		return _clientInstance;
	}

	public void EstablishConnection(String serverIp, int serverPort) {
		Log.i(TAG, "init client-server communication");
		this._serverIp = serverIp;
		this._serverPort = serverPort;

		try {
			InetAddress serverAddr = InetAddress.getByName(this._serverIp);
			_serverSocket = new Socket(serverAddr, _serverPort);
			Log.i(TAG, "Server on " + this._serverIp + ":" + _serverPort);

			if (_serverSocket != null) {
				// get stream to send data
				this._output = new DataOutputStream(
						this._serverSocket.getOutputStream());
			}
			// get stream to receive data
			// this._input = new BufferedReader(new
			// InputStreamReader(this._serverSocket.getInputStream()));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void SendData(String msg) {
		if (this._serverSocket != null && this._output != null) {
			try {
				Log.i(TAG, "sending=" + msg);
				this._output.writeBytes(msg);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	/*
	 * public String ReceiveData() { try { String read = _input.readLine();
	 * Log.i(TAG, "received="+ read); return read; } catch (IOException e) {
	 * e.printStackTrace(); return null; } }
	 */

	public void Stop() {
		try {
			// _input.close();
			_output.close();
			_serverSocket.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
